#include <iostream>
#include <stack>
#include <ranges>

using std::cin, std::cout, std::string, std::stack;
using ull = unsigned long long;
constexpr auto range = std::ranges::views::iota;

constexpr size_t MAX_N {(size_t)3e5+5}, MOD {998244353};
string s;
ull stk[MAX_N], pre[MAX_N], g[MAX_N], ans;
size_t tot;

int main(){
    cin>>s;
    for(const size_t i:range((size_t)0,s.size())){
        if(s[i]=='('){
            stk[tot++] = i;
        }else{
            pre[i] = stk[tot--];
            g[i] = ( g[pre[i]-1] + pre[i] ) % MOD;
            ans = ( ans + g[i] * s.size()-i) % MOD;
        }
    }
    cout<<ans<<'\n';
}